cgJsClass.gallery.views.singleViewClickEvents = {
    selection: null,
    range: null,
    sel: null,
    node: null,
    commentTitleBefore: '',
    commentTextBefore: '',
    focusInNoScrollTimeout: 1500,
    init: function ($) {

        function insertAtCursor(myField, myValue) {
            //IE support
            if (document.selection) {
                myField.focus();
                sel = document.selection.createRange();
                sel.text = myValue;
            }
            //MOZILLA and others
            else if (myField.selectionStart || myField.selectionStart == '0') {
                var startPos = myField.selectionStart;
                var endPos = myField.selectionEnd;
                myField.value = myField.value.substring(0, startPos)
                    + myValue
                    + myField.value.substring(endPos, myField.value.length);
                myField.selectionStart = startPos + myValue.length;
                myField.selectionEnd = startPos + myValue.length;
            } else {
                myField.value += myValue;
            }
        }

        $(document).on("focus input paste",'.cgCenterDiv .cg-center-image-comments-div-enter-textarea,.cgCenterDiv .cg-center-image-comments-div-enter-title', function (event){
            var start = this.selectionStart;
            var end = this.selectionEnd;
            cgJsClass.gallery.vars.selectionStart = start;
            cgJsClass.gallery.vars.selectionEnd = end;
        });

        $(document).on('click','.cg-emoji-select',function () {

            if(parseInt($(this).closest('.cg-center-image-comments-div-enter-container').find('.cg-center-image-comments-div-enter-counter').text())<=0){
                return;
            }
            var $contentEditable = $(this).closest('.cg-center-image-comments-div-enter-container').find('.cg-center-image-comments-div-enter-contenteditable');
            insertAtCursor($contentEditable.get(0), $(this).attr('data-emoji'));
            $contentEditable.focus();
            $contentEditable.get(0).selectionStart = cgJsClass.gallery.vars.selectionStart;
            $contentEditable.get(0).selectionEnd = cgJsClass.gallery.vars.selectionEnd;

            cgJsClass.gallery.views.singleViewFunctions.calculateChars($contentEditable);

        });

        $(document).on('click','.cg-emojis-add.cg-emojis-add-textarea,.cg-emojis-add.cg-emojis-add-title',function () {

            var $cgCenterImageCommentsDivEnterContainer = $(this).closest('.cg-center-image-comments-div-enter-container');
            var gid = $cgCenterImageCommentsDivEnterContainer.attr('data-cg-gid');

            var $cgEmojisDiv = $cgCenterImageCommentsDivEnterContainer.find('.cg-emojis-div');

            if($(this).hasClass('cg-emojis-add-textarea')){
                $(this).closest('.cg-center-image-comments-div-enter').find('.cg-center-image-comments-div-enter-title-div .cg-emojis-div').addClass('cg_hide');
                $(this).closest('.cg-center-image-comments-div-enter').find('.cg-center-image-comments-div-enter-title-div .cg-emojis-add').attr('data-cg-tooltip',cgJsClass.gallery.language[gid].AddAnEmoji);
            }else if($(this).hasClass('cg-emojis-add-title')){
                $(this).closest('.cg-center-image-comments-div-enter').find('.cg-center-image-comments-div-enter-textarea-div .cg-emojis-div').addClass('cg_hide');
                $(this).closest('.cg-center-image-comments-div-enter').find('.cg-center-image-comments-div-enter-textarea-div .cg-emojis-add').attr('data-cg-tooltip',cgJsClass.gallery.language[gid].AddAnEmoji);
            }

            if($cgEmojisDiv.hasClass('cg_hide')){
                $cgEmojisDiv.removeClass('cg_hide');
                $(this).attr('data-cg-tooltip',cgJsClass.gallery.language[gid].HideEmojis);
            }else{
                $cgEmojisDiv.addClass('cg_hide');
                $(this).attr('data-cg-tooltip',cgJsClass.gallery.language[gid].AddAnEmoji);
            }

        });

        $(document).on('focusin', '.cg-center-image-comments-div-enter-title',function(event) { //Prevent on paste as well
            if(cgJsClass.gallery.vars.isMobile){// otherwise might scroll to bottom or top during opening of keyboard!!!!!
                $('body > .mainCGdivHelperParent').addClass('cg_no_scroll');
                setTimeout(function (){
                    $('body > .mainCGdivHelperParent').removeClass('cg_no_scroll');
                },cgJsClass.gallery.views.singleViewClickEvents.focusInNoScrollTimeout);
            }
            $(this).closest('.cg-center-image-comments-div-enter').find('.cg-center-image-comments-div-enter-textarea-div .cg-emojis-div').addClass('cg_hide');
        });

        $(document).on('focusin', '.cg-center-image-comments-div-enter-textarea',function(event) { //Prevent on paste as well

            if(cgJsClass.gallery.vars.isMobile){// otherwise might scroll to bottom or top during opening of keyboard!!!!!

               var $mainCGdivHelperParent = $('body > .mainCGdivHelperParent');// otherwise might scroll to bottom or top during opening of keyboard!!!!!

                if(!$mainCGdivHelperParent.hasClass('cg_no_scroll')){
                    $mainCGdivHelperParent.addClass('cg_no_scroll');
                setTimeout(function (){
                        $mainCGdivHelperParent.removeClass('cg_no_scroll');
                    },cgJsClass.gallery.views.singleViewClickEvents.focusInNoScrollTimeout);
                }

           }

            // hide emojis of title (name) div if comment is focused
            $(this).closest('.cg-center-image-comments-div-enter').find('.cg-center-image-comments-div-enter-title-div .cg-emojis-div').addClass('cg_hide');

        });

        $(document).on('input', '.cg-center-image-comments-div-enter-textarea',function(event) { //Prevent on paste as well
            cgJsClass.gallery.views.singleViewFunctions.calculateChars($(this));
        });

        $(document).on('input', '.cg-center-image-comments-div-enter-title',function(event) { //Prevent on paste as well
            cgJsClass.gallery.views.singleViewFunctions.calculateChars($(this));
        });

        $(document).on("keydown",'.cgCenterDiv .cg-center-image-comments-div-enter-textarea,.cgCenterDiv .cg-center-image-comments-div-enter-title', function (event){
            var $element = $(this);
            var elementVal = $element.val();
            cgJsClass.gallery.vars.enteredTextBefore = elementVal;
        });

        $(document).on("input",'.cgCenterDiv .cg-center-image-comments-div-enter-textarea,.cgCenterDiv .cg-center-image-comments-div-enter-title', function (event){

            var $element = $(this);
            var $cgCenterDiv = $element.closest('.cgCenterDiv');
            var gid = $cgCenterDiv.attr('data-cg-gid');
            var elementVal = $element.val();
         //   console.log(elementVal);

            //if(cgJsClass.gallery.vars.regexEmoticons.test(elementVal)){

                if($element.hasClass('cg-center-image-comments-div-enter-textarea')){
                    cgJsClass.gallery.views.singleViewClickEvents.commentTextBefore =  cgJsClass.gallery.vars.enteredTextBefore;
                } else if($element.hasClass('cg-center-image-comments-div-enter-title')){
                    cgJsClass.gallery.views.singleViewClickEvents.commentTitleBefore =  cgJsClass.gallery.vars.enteredTextBefore;
                }

        });

        // ENTER textarea events (textarea) --- END

        $(document).on('click','.cg-image-image-href-to-copy',function () {

            var imageUrl = cgJsClass.gallery.views.singleView.createImageUrl($(this).attr('data-cg-gid'),$(this).attr('data-cg-real-id'),true);

            var el = document.createElement('textarea');
            el.value = imageUrl;
            el.setAttribute('readonly', '');
            el.style.position = 'absolute';
            el.style.left = '-9999px';
            document.body.appendChild(el);
            el.select();
            document.execCommand('copy');
            document.body.removeChild(el);

            cgJsClass.gallery.function.message.show(cgJsClass.gallery.language[$(this).attr('data-cg-gid')].ImageLinkCopied);

        });

        $(document).on('click','.cg-center-image-info-edit-icon-container',function () {

            if(!$(this).hasClass('cg_edit_started')){
                var $cgCenterDiv = $(this).closest('.cgCenterDiv ');
                cgJsClass.gallery.views.singleViewFunctions.editOpenInfoUserGallery($,this,$cgCenterDiv);
            }else{
                var $cgCenterDiv = $(this).closest('.cgCenterDiv ');
                cgJsClass.gallery.views.singleViewFunctions.editCloseInfoUserGallery($cgCenterDiv);
            }

        });

        $(document).on('click','.cg-center-image-info-save-text',function () {

            cgJsClass.gallery.user.editImageDataProcess($(this));

        });

        $(document).on('input paste','.cg-field-id-input-content.hasDatepicker',function (e) {
            this.value = '';
            return;
        });

        $(document).on('input change','.cg-field-id-input-content',function (e) {
            var $field = $(this);
            var elementVal = $field.val();

            //if(cgJsClass.gallery.vars.regexEmoticons.test(elementVal)){
            if(false){
                $field.val(elementVal.replace(cgJsClass.gallery.vars.regexEmoticons, ''));
                return;
            }

        });

        $(document).on('click','.cg-center-image-info-div-title .cg-center-image-comments-div-add-comment',function () {
            cgJsClass.gallery.views.singleViewFunctions.showCommentsAreaOnAddCommentClick($(this));
        });

        $(document).on('click','.cg-center-image-comments-div-parent > .cg-center-image-comments-div-add-comment',function () {
            cgJsClass.gallery.views.singleViewFunctions.showCommentsAreaOnAddCommentClick($(this));
        });

        $(document).on('click','.cg-center-image-close',function () {

            var gid = $(this).closest('.cgCenterDiv').attr('data-cg-gid');
            var realId = $(this).attr('data-cg-actual-realId');

            cgJsClass.gallery.views.close(gid,false,realId);

        });

        $(document).on('click','.cg-center-arrow-left',function () {

            jQuery(window).off('hashchange');
            cgJsClass.gallery.vars.keypressStartInSeconds = new Date().getTime()/1000;

            // braucht man zur Orientierung zwecks hash change
            cgJsClass.gallery.vars.showImageClicked = true;

            var gid = $(this).closest('.cgCenterDiv').attr('data-cg-gid');

            var order = parseInt(cgJsData[gid].vars.openedGalleryImageOrder)-1;

            //cgJsClass.gallery.views.singleViewFunctions.setSliderMargin(order,gid,'left');
            cgJsClass.gallery.views.functions.appendAndRemoveImagesInSlider(gid,order,cgJsData[gid].vars.maximumVisibleImagesInSlider,cgJsData[gid].vars.mainCGslider);

            cgJsClass.gallery.views.singleView.openImage($,order,false,gid,'left');

            cgJsClass.gallery.hashchange.activateHashChangeEvent();

        });

        $(document).on('click','.cg-center-arrow-right',function () {

            jQuery(window).off('hashchange');
            cgJsClass.gallery.vars.keypressStartInSeconds = new Date().getTime()/1000;

            // braucht man zur Orientierung zwecks hash change
            cgJsClass.gallery.vars.showImageClicked = true;

            var gid = $(this).closest('.cgCenterDiv').attr('data-cg-gid');

            var order = parseInt(cgJsData[gid].vars.openedGalleryImageOrder)+1;

            // cgJsClass.gallery.views.singleViewFunctions.setSliderMargin(order,gid,'right');
            cgJsClass.gallery.views.functions.appendAndRemoveImagesInSlider(gid,order,cgJsData[gid].vars.maximumVisibleImagesInSlider,cgJsData[gid].vars.mainCGslider);

            cgJsClass.gallery.views.singleView.openImage($,order,false,gid,'right');

            cgJsClass.gallery.hashchange.activateHashChangeEvent();

        });

        $(document).on('click','.cg_show_href_target_blank',function (e) {

            if(cgJsClass.gallery.vars.dom.body.hasClass('cg_gallery_rating_div_five_star_details_is_opened') || $(e.target).closest('.cg_gallery_rating_div_five_star_details').length){
                e.preventDefault();
                return;
            }
        });

        $(document).on('click', '.cg_append, .cg_gallery_info, .cg_gallery_info_title, div[id^="cg_show"] .cg_gallery_info', function(e){

            if($(e.target).hasClass('cg_delete_user_image')){
                return;
            }

            if($(this).hasClass('cg_gallery_info_href') || $(e.target).closest('.cg_gallery_info_href').length){
                return;
            }

            var $element = $(this);
            var $mainCGallery = $element.closest('.mainCGallery');
            var $mainCGslider = $element.closest('.mainCGslider');
            var $cg_show = $element.closest('.cg_show');

            var gid = $mainCGallery.attr('data-cg-gid');

            if(!cgJsData[gid].vars.isUserGallery && !cgJsData[gid].vars.isOnlyGalleryNoVoting && !cgJsData[gid].vars.isOnlyGalleryWinner){
                if($cg_show.length && !$mainCGslider.length){
                    if(($(e.target).hasClass('cg_gallery_rating_div') || $(e.target).closest('.cg_gallery_rating_div').length) && cgJsData[gid].options.general.RatingOutGallery==1 && !$element.hasClass('cg_open_gallery') && !$element.hasClass('cg_open_gallery_slider_look') && !cgJsClass.gallery.vars.isMobile){
                        return;
                    }
                }
            }

            if(cgJsData[gid].vars.isUserGallery){
                //  because click might in delete div which is placed in center div image parent
                if($(e.target).closest('.cg-center-image-parent').length){
                    return;
                }
            }

            if(cgJsData[gid].options.pro.IsModernFiveStar==1 && cgJsData[gid].options.general.RatingOutGallery==1 && cgJsClass.gallery.vars.isMobile && !$(this).hasClass('cg-pass-through') && !cgJsClass.gallery.vars.passThrough){

                if(($(e.target).closest('.cg_gallery_rating_div_child').length==1 && $(e.target).closest('.cg-center-image-rating-div').length==0)
                    || ($(e.target).hasClass('.cg_gallery_rating_div_child') && $(e.target).closest('.cg-center-image-rating-div').length==0)){

                    if(!$mainCGslider.length){
                        return;
                    }
                }

            }

            if(cgJsData[gid].options.pro.IsModernFiveStar==1 && cgJsData[gid].options.general.AllowRatingDynamic){
                if($mainCGslider.length>=1){
                    var $cg_show = $(this).closest('.cg_show');
                    if($cg_show.length>=1){
                        if(cgJsData[gid].options.general.FullSizeImageOutGallery!=1 && cgJsData[gid].options.general.OnlyGalleryView!=1){
                            $cg_show.find('.cg_gallery_rating_div_five_star_details').addClass('cg_hide');
                        }
                    }
                }
            }

            $(this).removeClass('cg-pass-through');
            cgJsClass.gallery.vars.passThrough = false;

            // braucht man zur Orientierung zwecks hash change
            cgJsClass.gallery.vars.showImageClicked = true;

            cgJsClass.gallery.function.general.tools.checkErrorAbort(gid);

            var sliderView = false;

            if(cgJsData[gid].vars.currentLook=='slider'){
                sliderView = true;
            }

            if(cgJsData[gid].options.general.FullSizeImageOutGallery==1 && sliderView == false){
                return;
            }

            if(cgJsData[gid].options.general.OnlyGalleryView==1 && sliderView == false){
                return;
            }

            e.preventDefault();

            var order = $element.closest('.cg_show').attr('data-cg-order');
            cgJsClass.gallery.views.functions.appendAndRemoveImagesInSlider(gid,order,cgJsData[gid].vars.maximumVisibleImagesInSlider,cgJsData[gid].vars.mainCGslider);
            var firstKey = Object.keys(cgJsData[gid].image[order])[0];
            var realId = cgJsData[gid].image[order][firstKey]['id'];
            var isGalleryOpened = false;

            var initFullWindow = false;

            if(cgJsData[gid].options.pro.SliderFullWindow==1 || cgJsData[gid].options.visual.BlogLookFullWindow==1){// has to be set to false then that always opens full window
                initFullWindow = true;
            }

          //  console.trace();

            if(((cgJsData[gid].options.general.FullSizeSlideOutStart==1 || cgJsData[gid].options.pro.SliderFullWindow==1 || cgJsData[gid].options.visual.BlogLookFullWindow==1)
                && !cgJsClass.gallery.vars.fullwindow
                && !cgJsData[gid].vars.galleryAlreadyFullWindow)
                ||(!cgJsClass.gallery.vars.fullwindow && initFullWindow==true)
            ){
                // cgJsData[gid].vars.galleryAlreadyFullWindow ganz wichtig!
                // check if is not slider view or blog view already,
                // has only to be done for thumb, row or height view
                if(!sliderView && cgJsData[gid].vars.currentLook!='blog'){

                    // then rating must be clicked!!!!! SAME CONDITION IS BELOW, HAS TO BE SUMERRIZED
                    if(typeof $element.find('.cg_rate_star')[ 0 ] == 'undefined' && $element.hasClass('cg_gallery_info')){

                        if(cgJsClass.gallery.function.general.tools.checkIfNoRating(gid)){
                            cgJsData[gid].vars.openedRealId = realId;
                            cgJsClass.gallery.views.fullwindow.openFunction(gid,$('<div data-cg-real-id="'+realId+'"></div>'));
                        }else{
                            return;
                        }

                    }else{

                        cgJsData[gid].vars.openedRealId = realId;
                        cgJsClass.gallery.views.fullwindow.openFunction(gid,$('<div data-cg-real-id="'+realId+'"></div>'));

                    }

                    // jQuery('#cg_append'+realId+'').click();
                    return;
                }

            }
            var isGalleryOpenedSliderLook = false;

            if($element.hasClass('cg_open_gallery')){
                $element.removeClass('cg_open_gallery');
                isGalleryOpened = true;
            }
            if($element.hasClass('cg_open_gallery_slider_look')){

                $element.removeClass('cg_open_gallery_slider_look');

                if(sliderView==true){
                    isGalleryOpenedSliderLook = true;
                }
            }

            var direction = undefined;
            if(typeof cgJsData[gid].vars.openedGalleryImageOrder != null){
                if(parseInt(order) >= parseInt(cgJsData[gid].vars.openedGalleryImageOrder)){
                    direction = 'right';
                }
                if(parseInt(order) < parseInt(cgJsData[gid].vars.openedGalleryImageOrder)){
                    direction = 'left';
                }
            }

            //cgJsClass.gallery.views.singleViewFunctions.setSliderMargin(order,gid,direction,isGalleryOpenedSliderLook,realId);

            // then rating must be clicked!!!!!
            if(typeof $element.find('.cg_rate_star')[ 0 ] == 'undefined' && $element.hasClass('cg_gallery_info')){

                if(cgJsClass.gallery.function.general.tools.checkIfNoRating(gid)){
                    cgJsClass.gallery.views.singleView.openImage($,order,false,gid,direction,isGalleryOpened,isGalleryOpenedSliderLook);
                }else{
                    return;
                }

            }else{
                cgJsClass.gallery.views.singleView.openImage($,order,false,gid,direction,isGalleryOpened,isGalleryOpenedSliderLook);
            }

        });


        jQuery(document).on('click','.cg-center-image-comments-div-show-more-comments',function () {

            var $element = jQuery(this);
            var $cgCenterDiv = $element.closest('.cgCenterDiv');

            if($element.hasClass('cg-center-image-show-more-expanded')){
                $cgCenterDiv.find('.cg-center-image-comments-div-parent-parent').removeClass('cg-center-image-show-more-expanded');
                $cgCenterDiv.find('.cg-center-image-comments-div-parent').removeClass('cg-center-image-show-more-expanded');
                $element.removeClass('cg-center-image-show-more-expanded').attr('data-cg-tooltip',cgJsClass.gallery.language[$cgCenterDiv.attr('data-cg-gid')].ShowMoreComments);
            }else{
                $cgCenterDiv.find('.cg-center-image-comments-div-parent-parent').addClass('cg-center-image-show-more-expanded');
                $cgCenterDiv.find('.cg-center-image-comments-div-parent').addClass('cg-center-image-show-more-expanded');
                $element.addClass('cg-center-image-show-more-expanded').attr('data-cg-tooltip',cgJsClass.gallery.language[$cgCenterDiv.attr('data-cg-gid')].ShowLessComments);
            }

        });


        jQuery(document).on('click','.cg-center-image-comments-div-show-more-info',function () {

            var $element = jQuery(this);
            var $cgCenterDiv = $element.closest('.cgCenterDiv');

            if($element.hasClass('cg-center-image-show-more-expanded')){
                $cgCenterDiv.find('.cg-center-image-info-div-parent-parent').removeClass('cg-center-image-show-more-expanded');
                $cgCenterDiv.find('.cg-center-image-info-div-container').removeClass('cg-center-image-show-more-expanded');
                $element.removeClass('cg-center-image-show-more-expanded').attr('data-cg-tooltip',cgJsClass.gallery.language[$cgCenterDiv.attr('data-cg-gid')].ShowMoreInfo);
            }else{
                $cgCenterDiv.find('.cg-center-image-info-div-parent-parent').addClass('cg-center-image-show-more-expanded');
                $cgCenterDiv.find('.cg-center-image-info-div-container').addClass('cg-center-image-show-more-expanded');
                $element.addClass('cg-center-image-show-more-expanded').attr('data-cg-tooltip',cgJsClass.gallery.language[$cgCenterDiv.attr('data-cg-gid')].ShowLessInfo);
            }

        });


        jQuery(document).on('click','.cg-center-image',function () {

            var $element = jQuery(this);

            //if($cgCenterDiv.width()<=750){
            // in the way it works makes only sence on mobiles
            if(cgJsClass.gallery.vars.isMobile && $element.width()<=750){

                var $cgCenterDiv = $element.closest('.cgCenterDiv');
                var gid = $cgCenterDiv.attr('data-cg-gid');
                var realId = $cgCenterDiv.attr('data-cg-real-id');

                cgJsClass.gallery.views.singleViewFunctions.zoom(jQuery,$element,gid,realId);

            }

        });

        jQuery(document).on('click','.cg_zoom_close',function () {
            cgJsClass.gallery.views.singleViewFunctions.zoomClose(jQuery,$(this));
        });

        jQuery(document).on('click','.cg-center-show-profile-image,.cg-center-image-comments-profile-image',function () {

            var gid =$(this).closest('.cgCenterDiv').attr('data-cg-gid');
            var realId =$(this).closest('.cgCenterDiv').attr('data-cg-real-id');
            var $cgCenterInfoDiv = $(this).closest('.cg-center-info-div');

            var nickname = '';

            if(cgJsData[gid].vars.rawData[realId]['WpUserId']){
                if(cgJsClass.gallery.vars.nicknames[cgJsData[gid].vars.rawData[realId]['WpUserId']]){
                    nickname = cgJsClass.gallery.vars.nicknames[cgJsData[gid].vars.rawData[realId]['WpUserId']];
                }
            }

            var profileImage = '';
            if(cgJsData[gid].vars.rawData[realId]['WpUserId']){
                if(cgJsClass.gallery.vars.profileImages[cgJsData[gid].vars.rawData[realId]['WpUserId']]){
                    profileImage = cgJsClass.gallery.vars.profileImages[cgJsData[gid].vars.rawData[realId]['WpUserId']];
                }
            }

            if((cgJsData[gid].options.pro.ShowNickname && nickname) || $cgCenterInfoDiv.length){
                cgJsClass.gallery.function.message.showPro('<div class="cg-center-show-profile-image-full-nickname">'+nickname+'</div><div class="cg-center-show-profile-image-full-show" style="background-image: url('+profileImage+');"></div>');
            }else{
                cgJsClass.gallery.function.message.showPro('<div class="cg-center-show-profile-image-full-show" style="background-image: url('+profileImage+');"></div>');
            }

        });

    }
};